from MSQRlib import *   #魔方陣用共通関数
Stab=[[17,24, 1, 8,15],[23, 5, 7,14,16],
      [ 4, 6,13,20,22],[10,12,19,21, 3],
      [11,18,25, 2, 9]]
#Stab=[[4,9,2],[3,5,7],[8,1,6]]
def setGtab(Stab):return setGtabX(Stab,4)
def setR(R,ii,jj,G,L):
    R[ii  ][jj  ]=G+L[0][0];R[ii  ][jj+1]=G+L[0][1]
    R[ii+1][jj  ]=G+L[1][0];R[ii+1][jj+1]=G+L[1][1]
def genSame(Gtab,R,N,startL, endL,UMat):#■同一行列使用
    for i in range(startL,endL):
        ii=i*2
        for j in range(N):jj=j*2;setR(R,ii,jj,Gtab[i][j],UMat)
def genUcenter(Gtab,R,N,UM,N0,NC,UC):#■中央のみ別行列使用
    i=N0;ii=i*2
    for j in range(N):
        jj=j*2
        if j==NC:setR(R,ii,jj,Gtab[i][j],UC)
        else    :setR(R,ii,jj,Gtab[i][j],UM)
def LUX(Gtab):#■LUX法による生成
    L=[[4,1],[2,3]];U=[[1,4],[2,3]];X=[[1,4],[3,2]]
    N=len(Gtab);R=array(2*N,2*N);N0=int((N+1)/2)
    genSame(Gtab,R,N,0, N0-1,L)
    genUcenter(Gtab,R,N,L,N0-1,N0-1,U)
    genUcenter(Gtab,R,N,U,N0,N0-1,L)
    genSame(Gtab,R,N,N0+1, N,X)
    return R
print("■元の魔方陣"); printSQR(Stab)
Gtab=setGtab(Stab)
print("■基準魔方陣"); printSQR(Gtab)
R=LUX(Gtab)
print("■結果"); printSQR(R)


